<?php

include("config.php");

?><html>
<head>
<title>Routes Admin Panel</title>
<link href="/css/bootstrap.min.css" rel="stylesheet" >
<script src="/js/jquery-3.6.0.min.js" ></script>
<script src="/js/bootstrap.bundle.min.js" ></script>
</head>
<body>

<div id="BASE" data-hash="NOT_INITIALIZED">
   <div>
      <h3><b>VPNs:</b></h1>
   </div>
   <div id="VPNcontainer">
     <div>
        <div class="btn-group btn-group-sm" role="group" id="VPN" >
<?php
   foreach($vpns as $vpnname => $vpnvars) {
      echo "            <button type='button' data-vpn='".$vpnname."' class='btn vpnbtn'>".$vpnvars['but']."</button>\n";
   }
?>
        </div>
     </div><hr>
   </div>
   <div>
      <h3><b>DHCP HOSTS:</b></h1>
   </div>
   <div id="DHCP">
   </div>
   <div>
      <h3><b>FIXED IP HOSTS:</b></h1>
   </div>
	<div id="FIXED">
	</div>
</div>
<script language="javascript">

function activeButton(route, act) {
   if(route == act) return "btn-primary";
   return 'btn-secondary';
}


function addButton(block, ip, name, route) {
	           $(block).append(
               '<div>'+
               '  <div data-ip="'+ip+'" data-name="'+name+'"><b>'+ip+' - '+name+' </b><br /></div>'+
               '  <div class="btn-group btn-group-sm" role="group" id="'+ip+'" >'+ 
               '     <button type="button" data-ip="'+ip+'" data-route="no" class="hostbtn btn '+activeButton("no", route)+'">DEFAULT</button>' +
<?php
foreach($vpns as $vpnname => $vpnvars) {
   ?>      '     <button type="button" data-ip="'+ip+'" data-route="<?php
   echo $vpnvars['var'];
   ?>" class="hostbtn btn '+activeButton("<?php 
   echo $vpnvars['var'];
   ?>", route)+'"><?php
   echo $vpnvars['but'];
?></button>' +
<?php

}
?>               '     <button type="button" data-ip="'+ip+'" data-route="tor" class="hostbtn btn '+activeButton("tor", route)+'"> -TOR- </button>' +
               '     <button type="button" data-ip="'+ip+'" data-route="rain" class="hostbtn btn '+activeButton("rain", route)+'"> RAIN </button>' +
               '     <button type="button" data-ip="'+ip+'" data-route="block" class="hostbtn btn '+activeButton("block", route)+'"> BLOCK </button>' +
               '  </div>'+
               '</div>'+
               '<hr>'
           );
}

function updateButton(ip, name, route) {
			$('div[data-ip="'+ip+'"]').attr('data-name', name);
			$('div[data-ip="'+ip+'"] b').text(ip+" - "+name);
			$('button[data-ip="'+ip+'"]').attr('data-name', name);
			$('button[data-ip="'+ip+'"].btn-primary').removeClass('btn-primary').addClass('btn-secondary');
			$('button[data-ip="'+ip+'"][data-route="'+route+'"]').removeClass('btn-secondary').addClass('btn-primary');
}

function refreshData(data) {
   if($("#BASE").attr('data-hash') != data.uphash) {
		$("#BASE").attr('data-hash', data.uphash);
      $.each(data.dhcp, function(ip, v) {
         if(document.getElementById(ip)) {
				updateButton(ip, v.name, v.route);
         } else {
				addButton("#DHCP", ip, v.name, v.route);
         }
      });

      $.each(data.fixed, function(ip, v) {
         if(document.getElementById(ip)) {
				updateButton(ip, v.name, v.route);
         } else {
            addButton("#FIXED", ip, v.name, v.route);
         }
      });
    }
    $.each(data.vpn, function(vpnname, vpnvars) {
       if(vpnvars.vpnstatus == 'UP') {
          $('button[data-vpn="'+vpnname+'"].btn-danger').removeClass('btn-danger');
          $('button[data-vpn="'+vpnname+'"].btn-danger').removeClass('btn-warning');
          $('button[data-vpn="'+vpnname+'"]').addClass('btn-success');
       } else {
          $('button[data-vpn="'+vpnname+'"].btn-success').removeClass('btn-success');
          if(vpnvars.vpnneeded == 'Y') {
             $('button[data-vpn="'+vpnname+'"].btn-danger').removeClass('btn-danger');
             $('button[data-vpn="'+vpnname+'"]').addClass('btn-warning');
          } else {
             $('button[data-vpn="'+vpnname+'"].btn-warning').removeClass('btn-warning');
             $('button[data-vpn="'+vpnname+'"]').addClass('btn-danger');
          }
       }
    });
};

function getData() {
   $.getJSON("route.php", refreshData);
}

function sendButton() {
   var ip = $(this).attr('data-ip');
   var route = $(this).attr('data-route');
   $.ajax('setroute.php', {
      type: 'POST',
      data: { 'ip': ip, 'route': route },
      success: getData
   });
}

function sendVPNstop() {
   var name = $(this).attr('data-vpn');
   $.ajax('stopvpn.php', {
      type: 'POST',
         data: { 'name': name },
         success: getData
   });
}

$(document).ready(function() {
	getData();
   $("#DHCP").on('click', '.hostbtn',  sendButton);
   $("#FIXED").on('click', '.hostbtn', sendButton);
   $("#VPN").on('click', '.vpnbtn', sendVPNstop);
	setInterval(getData, 2000);
});
</script>
</body>
</html>
